/*
 * Author strongly advices against using this code, or a part of it,
 * in an application designed to run on any Microsoft(tm) platfrom.
 *
 * See doc/README for more information about COPYING terms.
 */
#include "mcd.h"

int cd_init(const char *cdpath, struct mcd *cd) {

 cd->fd=open(cdpath,O_RDONLY|O_NONBLOCK);
 if (cd->fd<0) return -1;
 if ((cd->cdstat[0]=ioctl(cd->fd,CDROM_DISC_STATUS,NULL)<0)) return -1;
 if (cd->cdstat[0]==(100||105)) return -2;
 return 0;
}

/* needs correct cd->fd; seems very efficient (no division qnd such) */
int cd_readtracks(struct mcd *cd) {
 int i, sec, frame;
 struct track tmp[MCD_CDAUDIO_MAX]; /* Tmp Stuff */
 struct cdrom_tochdr cdth;        /* TocHdr Stuff */

 if (ioctl(cd->fd, CDROMREADTOCHDR, &cdth)<0) {
  draw_status("can't read disc       ",0);
  return -1;
 }
 /* track[1] - [last-1])*/
 for(i=1;i<=cdth.cdth_trk1 && i<=MCD_CDAUDIO_MAX;i++) {
  cd->cdte[i].cdte_track=i;
  cd->cdte[i].cdte_format=CDROM_MSF;
  if (ioctl(cd->fd, CDROMREADTOCENTRY, &cd->cdte[i])<0) {
   draw_status("can't read disc       ",0);
   return -1;
  } else {
   cd->t[i].audio=cd->cdte[i].cdte_ctrl & CDROM_DATA_TRACK;
   tmp[i].min=cd->cdte[i].cdte_addr.msf.minute;
   tmp[i].sec=cd->cdte[i].cdte_addr.msf.second;
   frame=cd->cdte[i].cdte_addr.msf.frame;
   cd->t[i-1].min=tmp[i].min-tmp[i-1].min;
   sec=(cd->t[i-1].sec=tmp[i].sec-tmp[i-1].sec);
   if (frame>37) cd->t[i-1].sec++; /* rounding a bit :) */
   if (sec<0) {
    cd->t[i-1].min--;cd->t[i-1].sec+=60;
   }
  }
 }
 /* now the leadout for track[0] + track[last] */
 cd->cdte[0].cdte_track=CDROM_LEADOUT;
 cd->cdte[0].cdte_format=CDROM_MSF;
 if (ioctl(cd->fd, CDROMREADTOCENTRY, &cd->cdte[0])<0) {
  draw_status("can't read disc       ",0);
  return -1;
 } else {
  cd->t[0].audio=cd->cdte[0].cdte_ctrl & CDROM_DATA_TRACK;
  cd->t[0].min=cd->cdte[0].cdte_addr.msf.minute;
  cd->t[0].sec=cd->cdte[0].cdte_addr.msf.second;
  frame=cd->cdte[0].cdte_addr.msf.frame;
  cd->t[i-1].min=cd->t[0].min-tmp[i-1].min;
  sec=(cd->t[i-1].sec=cd->t[0].sec-tmp[i-1].sec);
  if (frame>37) cd->t[i-1].sec++; /* rounding a bit :) */
  if (sec<0) {
   cd->t[i-1].min--;cd->t[i-1].sec+=60;
  }
 }
 cd->title[1]=cdth.cdth_trk1; /* last playable title */
 updates[U_TRACKS]=1;
 return cdth.cdth_trk1;
}

/* normal/update/dirty, last value counts */
int cd_readsubchannel(struct mcd *cd) {
 struct cdrom_volctrl cdv; /* Volume Stuff */

 /* trackinfos */
 cd->cds.cdsc_format = CDROM_MSF; /* reading MSF format */
 if (ioctl(cd->fd,CDROMSUBCHNL,&cd->cds)<0) return -1;

 /* audiostatus changed */
 if (cd->cds.cdsc_audiostatus!=cd->cdstat[0]) {
  cd->cdstat[0]=cd->cds.cdsc_audiostatus;
  updates[U_STATUS]=1;
 }

 /* volume(0..3) changed */
 if (ioctl(cd->fd,CDROMVOLREAD,&cdv)<0) return -1;
 if (cdv.channel0!=cd->vol.channel0) {
  cd->vol.channel0=cdv.channel0; updates[U_VOLUME]=1; }
 if (cdv.channel1!=cd->vol.channel1) {
  cd->vol.channel1=cdv.channel1; updates[U_VOLUME]=1; }
 if (cdv.channel2!=cd->vol.channel2) {
  cd->vol.channel2=cdv.channel2; updates[U_VOLUME]=1; }
 if (cdv.channel3!=cd->vol.channel3) {
  cd->vol.channel3=cdv.channel3; updates[U_VOLUME]=1; }

 /* track changed */
 if (cd->cds.cdsc_trk!=cd->title[0]) { /* title[0]=current title[1]=max */
  if (cd->method[0]==M_REPEAT_TRK) {
   cd_start(&cd[0]);
   return cd->title[0];
  }
  cd->title[0]=cd->cds.cdsc_trk;
  updates[U_TRACKS]=1;
 }
 return cd->cds.cdsc_trk; /* current title may be usefull :) */
}


/* title[0]=current / title[1]=last */
void cd_start(struct mcd *cd) {
 register int tmp=0;
 struct cdrom_msf msf;

 if (cd->title[0]>cd->title[1]) {
  draw_status("what do you want ?    ",1);return;
 } else {
  tmp=(cd->title[0]<=cd->title[1])?cd->title[0]:0; /* track or leadout? */
 }

 msf.cdmsf_min0   = cd->cdte[cd->title[0]].cdte_addr.msf.minute;
 msf.cdmsf_sec0   = cd->cdte[cd->title[0]].cdte_addr.msf.second;
 msf.cdmsf_frame0 = cd->cdte[cd->title[0]].cdte_addr.msf.frame;
 msf.cdmsf_sec1   = cd->cdte[0].cdte_addr.msf.second;
 msf.cdmsf_min1   = cd->cdte[0].cdte_addr.msf.minute;
 msf.cdmsf_frame1 = cd->cdte[0].cdte_addr.msf.frame;

/* for DEBUGGING the methods :) 
 gotoxy(80,30);
 _printf("\ntmp=%02d t[0]=%02d t[1]=%02d %02d:%02d->%02d:%02d",
 tmp,cd->title[0],cd->title[1],
 msf.cdmsf_min0, msf.cdmsf_sec0,
 msf.cdmsf_min1, msf.cdmsf_sec1);
*/
 if (cd->cds.cdsc_audiostatus == CDROM_AUDIO_PLAY) {
  if (ioctl(cd->fd,CDROMPAUSE,NULL)<0)
   draw_status("error, while stopping ",1);
 }
 if (ioctl(cd->fd,CDROMPLAYMSF, &msf)<0)
  draw_status("error, while playing  ",1);
}


/* only for skipping, rest is done via cd_play(..)! */
void cd_skip(struct mcd *cd, int secs) {
 struct cdrom_msf msf;

 if (cd->method[0]==M_INTRO) return;
 secs += cd->cds.cdsc_absaddr.msf.minute * 60 + cd->cds.cdsc_absaddr.msf.second;
 msf.cdmsf_min0   = secs / 60;
 msf.cdmsf_sec0   = secs % 60;
 msf.cdmsf_frame0 = 0;
 msf.cdmsf_min1   = cd->cdte[cd->title[1]].cdte_addr.msf.minute;
 msf.cdmsf_sec1   = cd->cdte[cd->title[1]].cdte_addr.msf.second;
 msf.cdmsf_frame1 = cd->cdte[cd->title[1]].cdte_addr.msf.frame;

 if (cd->cds.cdsc_audiostatus == CDROM_AUDIO_PLAY) {
 if (ioctl(cd->fd,CDROMPAUSE,NULL)<0)
   draw_status("error, while stopping ",1);
 }
 if (ioctl(cd->fd,CDROMPLAYMSF, &msf)<0)
   draw_status("error, while playing  ",1);
}

void cd_stop(struct mcd *cd) {
 if (cd->cdstat[0]==CDROM_AUDIO_PLAY)
 ioctl(cd->fd,CDROMSTOP,NULL);
}

void cd_pauseresume(struct mcd *cd) {
 switch (cd->cdstat[0]) {
 case CDROM_AUDIO_PLAY:
  ioctl(cd->fd,CDROMPAUSE,NULL);
 break;
 case CDROM_AUDIO_PAUSED:
  ioctl(cd->fd,CDROMRESUME,NULL);
 break;
 }
}

void cd_eject(int *fd) {
 draw_status("opening cdrom         ",0);
 ioctl(*fd,CDROMSTOP,NULL);
 ioctl(*fd,CDROMEJECT,NULL);
 havecd=0;
}

void cd_close(int *fd) {
 draw_status("reading cdrom         ",0);
 ioctl(*fd,CDROMCLOSETRAY,NULL);
 havecd=1;
}

