/*
 * Author strongly advices against using this code, or a part of it,
 * in an application designed to run on any Microsoft(tm) platfrom.
 *
 * See doc/README for more information about COPYING terms.
 */
#include "mcd.h"

short pluskey=0; /* 0..9 -> track XN is played */
short maxx,maxy; /* screenmaxima */

/* 0=status 1=method 2=volume 3=tracks 4=cd-change(l8er)
 * 4=ALL (times,pluskey always!)
 */
short updates[5];
short havecd;

void mcd_init(void) {
 tty_mode(TERM_INIT);
 clear();
 tty_getsize(&maxx,&maxy);
 if (maxx<60 || maxy<15) {
  show2("Sorry, you need at least a termsize of 60x15.\n");
  tty_mode(TERM_QUIT);
 }
}

void mcd_quit(void) {
 show1(T_NORMAL);clear();
 show_b("ByeBye...\n\n");
 tty_mode(TERM_QUIT);
}

int main(int argc, char **argv, char **environ) {
 struct mcd *cd=malloc(sizeof(struct mcd));
 int quit=0,i;
 char ch;

 if (argc>1) quit=cd_init(argv[1],&cd[0]);
 else quit=cd_init(CDROM_DEFAULT,&cd[0]);
 switch (quit) {
  case -2:
   _printf("Sorry, your disc in %s isn't a Mixed-CD or Audio-CD !\n",CDROM_DEFAULT);
   exit(1);
   break;
  case -1:
   _printf("Sorry, can't open cd-device: \"%s\" !\n",(argc>1)?argv[1]:CDROM_DEFAULT);
   exit(1);
   break;
 }
 havecd=1;
 mcd_init();
 draw_initscr();
 for (i=0;i<=5;i++) updates[i]=1;

 for (;!quit;) {
  draw_updatescr(&cd[0]);
  if (1 == select_wait(0,1)) {
   read(0,&ch,1);
   switch (ch) {
  /* m=method s=start/stop(real) p=pause/resume
   * q=quit e=eject c=close r=resize (+signal l8er)
   * <>= volume  (+/-)=track +/-  cursor=ff/fw/..
   * maybe editing in later times :)
   */
   case '\033':
    read(0,&ch,1);read(0,&ch,1); /* XXX - should be done in another way ? */
    switch(ch) {
     case 'A': cd_skip(&cd[0], FW_FAST);break; /*t*/
     case 'B': cd_skip(&cd[0],-RW_FAST);break; /*b*/
     case 'C': cd_skip(&cd[0], FW_SLOW);break; /*l*/
     case 'D': cd_skip(&cd[0],-RW_SLOW);break; /*r*/
    }
    break;
   case 'r':
   case 'R':
    for (i=0;i<=5;i++) updates[i]=1;
    break;
   case 'm':
    updates[U_METHOD]=1;
    if (cd->method[0]<M_INTRO) cd->method[0]++;
    else cd->method[0]=M_PLAY_CD;
    break;
   case 'M':
    updates[U_METHOD]=1;
    if (cd->method[0]>M_PLAY_CD) cd->method[0]--;
    else cd->method[0]=M_INTRO;
    break;
   case 'P':
   case 'p':
    cd_pauseresume(&cd[0]);
    updates[U_STATUS]=1;
    break;
   case 'S':
   case 's':
    if (cd->cdstat[0]==CDROM_AUDIO_PLAY) cd_stop(&cd[0]);
    else {cd->title[0]=1;cd_start(&cd[0]);}
    updates[U_STATUS]=1;
    break;
   case 'E':
   case 'e':
    cd_eject(&cd->fd);
    updates[U_TRACKS]=updates[U_STATUS]=1;
    break;
   case 'C':
   case 'c':
    cd_close(&cd->fd);
    updates[U_TRACKS]=updates[U_STATUS]=1;
    break;
   case '+':
    pluskey=(pluskey<9)?++pluskey:0;
    updates[U_TRACKS]=1;
    break;
   case '-':
    pluskey=(pluskey>0)?--pluskey:9;
    updates[U_TRACKS]=1;
    break;
   case '<':
    cd->vol.channel0=cd->vol.channel1=cd->vol.channel2=cd->vol.channel3=
     (cd->vol.channel0>0)?cd->vol.channel0-=3:255;
    if (ioctl(cd->fd,CDROMVOLCTRL,&cd->vol)<0)
     draw_status("error, setting volume ",1);
    updates[U_VOLUME]=1;
    break;
   case '>':
    cd->vol.channel0=cd->vol.channel1=cd->vol.channel2=cd->vol.channel3=
     (cd->vol.channel0<255)?cd->vol.channel0+=3:0;
    if (ioctl(cd->fd,CDROMVOLCTRL,&cd->vol)<0)
     draw_status("error, setting volume ",1);
    updates[U_VOLUME]=1;
    break;
   case 'q':
   case 'Q':
    quit=1; break;
   case '0':
   case '1':
   case '2':
   case '3':
   case '4':
   case '5':
   case '6':
   case '7':
   case '8':
   case '9':
    if ((pluskey==0)&&((int)ch-48)==0) {
     draw_status("hey, this isn't valid!",1);
     break;
    } else {
     cd->title[0]=((pluskey*10)+((int)ch-48));
     cd_start(&cd[0]);
    }
    updates[U_TRACKS]=updates[U_STATUS]=1;
    break;
   }
  }
 }
 mcd_quit(); /* cleanup */
 exit(0);
}
